Package org.zkoss.zkmax.zul

## Class Lineitem

- java.lang.Object
- - org.zkoss.zk.ui.AbstractComponent
  - - org.zkoss.zk.ui.HtmlBasedComponent
    - - org.zkoss.zul.impl.XulElement
      - - org.zkoss.zkmax.zul.Lineitem

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Cloneable`, `Component`, `Scope`, `ComponentCtrl`

      public class Lineitem
      extends XulElement

  A lineitem.

  Lineitem is the child of Linelayout, it can contain up to 2 components inside.

  Default `HtmlBasedComponent.getZclass()`: z-lineitem

  Since:
    9.0.0
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `protected class` | `Lineitem.ExtraCtrl` |

    - ### Nested classes/interfaces inherited from class org.zkoss.zk.ui.AbstractComponent

      `AbstractComponent.Children, AbstractComponent.ForwardInfo, AbstractComponent.TargetInfo`

  - ### Field Summary

    - ### Fields inherited from class org.zkoss.zk.ui.HtmlBasedComponent

      `_zclass`

    - ### Fields inherited from interface org.zkoss.zk.ui.Component

      `APPLICATION_SCOPE, COMPONENT_SCOPE, DESKTOP_SCOPE, PAGE_SCOPE, REQUEST_SCOPE, SESSION_SCOPE, SPACE_SCOPE`

    - ### Fields inherited from interface org.zkoss.zk.ui.sys.ComponentCtrl

      `AFTER_CHILD_ADDED, AFTER_CHILD_REMOVED, AFTER_CLONED, AFTER_PAGE_ATTACHED, AFTER_PAGE_DETACHED, AFTER_PARENT_CHANGED, CE_BUSY_IGNORE, CE_DUPLICATE_IGNORE, CE_IMPORTANT, CE_NON_DEFERRABLE, CE_REPEAT_IGNORE`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Lineitem()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `beforeChildAdded​(Component child, Component refChild)` | Default: does nothing.
    `void` | `beforeParentChanged​(Component parent)` | Default: If parent is null, execute the @Destroy method if any.
    `java.lang.String` | `getBackSpace()` | Returns the spacing with the next lineitem.
    `java.lang.Object` | `getExtraCtrl()` | Returns the client control for this component.
    `java.lang.String` | `getFrontSpace()` | Returns the spacing with the previous lineitem.
    `java.lang.String` | `getPointIconSclass()` | Returns the iconSclass name of this point.
    `Image` | `getPointImageContent()` | Returns the source content of the point image.
    `java.lang.String` | `getPointImageSrc()` | Returns the source URI of the point image.
    `java.lang.String` | `getPointStyle()` | Returns the CSS style for the point.
    `boolean` | `isOpposite()` | Returns whether the first child is displayed in the first area(left/top).
    `boolean` | `isPointVisible()` | Returns whether the point is visible.
    `protected void` | `renderProperties​(ContentRenderer renderer)` | Renders the content of this component, excluding the enclosing tags and children.
    `void` | `setBackSpace​(java.lang.String backSpace)` | Sets the spacing with the next lineitem.
    `void` | `setFrontSpace​(java.lang.String frontSpace)` | Sets the spacing with the previous lineitem.
    `void` | `setOpposite​(boolean opposite)` | Sets whether the first child is displayed in the first area(left/top).
    `void` | `setPointIconSclass​(java.lang.String pointIconSclass)` | Sets the iconSclass name of the point.
    `void` | `setPointImageContent​(java.awt.image.RenderedImage image)` | Sets the pointImageContent directly with the rendered image.
    `void` | `setPointImageContent​(Image image)` | Sets the pointImageContent directly.
    `void` | `setPointImageSrc​(java.lang.String src)` | Sets the source URI of the point image.
    `void` | `setPointStyle​(java.lang.String pointStyle)` | Sets the pointStyle.
    `void` | `setPointVisible​(boolean pointVisible)` | Sets whether the point is visible.

    - ### Methods inherited from class org.zkoss.zul.impl.XulElement

      `clone, getContext, getCtrlKeys, getPopup, getPropertyAccess, getTooltip, setContext, setContext, setContextAttributes, setCtrlKeys, setPopup, setPopup, setPopupAttributes, setTooltip, setTooltip, setTooltipAttributes`

    - ### Methods inherited from class org.zkoss.zk.ui.HtmlBasedComponent

      `addSclass, evalCSSFlex, focus, getAction, getClientAction, getDraggable, getDroppable, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTabindexInteger, getTooltiptext, getTop, getVflex, getWidth, getZclass, getZindex, getZIndex, removeSclass, removeSclass, service, setAction, setClass, setClientAction, setDraggable, setDroppable, setFocus, setHeight, setHeight0, setHeightDirectly, setHflex, setHflex0, setHflexDirectly, setLeft, setLeftDirectly, setRenderdefer, setSclass, setStyle, setTabindex, setTabindex, setTooltiptext, setTop, setTopDirectly, setVflex, setVflex0, setVflexDirectly, setWidth, setWidth0, setWidthDirectly, setZclass, setZindex, setZIndex, setZIndexDirectly`

    - ### Methods inherited from class org.zkoss.zk.ui.AbstractComponent

      `addAnnotation, addCallback, addClientEvent, addEventHandler, addEventListener, addEventListener, addForward, addForward, addForward, addForward, addMoved, addRedrawCallback, addScopeListener, addShadowRoot, addShadowRootBefore, addSharedEventHandlerMap, appendChild, applyProperties, beforeChildRemoved, destroyIndexCacheMap, detach, didActivate, didActivate, didDeserialize, didDeserialize, disableBindingAnnotation, disableClientUpdate, disableHostChanged, enableBindingAnnotation, enableHostChanged, getAnnotatedProperties, getAnnotatedPropertiesBy, getAnnotation, getAnnotations, getAnnotations, getAttribute, getAttribute, getAttribute, getAttributeOrFellow, getAttributes, getAttributes, getAuService, getAutag, getCallback, getChildren, getClientAttribute, getClientDataAttribute, getClientEvents, getDefaultMold, getDefinition, getDesktop, getEventHandler, getEventHandlerNames, getEventListenerMap, getEventListeners, getFellow, getFellow, getFellowIfAny, getFellowIfAny, getFellows, getFirstChild, getForwards, getId, getIndexCacheMap, getLastChild, getMold, getNextSibling, getPage, getParent, getPreviousSibling, getRedrawCallback, getRoot, getShadowFellowIfAny, getShadowRoots, getShadowVariable, getShadowVariable, getShadowVariable0, getSpaceOwner, getSpecialRendererOutput, getStubonly, getSubBindingAnnotationCount, getTemplate, getTemplateNames, getUuid, getWidgetAttributeNames, getWidgetClass, getWidgetListener, getWidgetListenerNames, getWidgetOverride, getWidgetOverrideNames, hasAttribute, hasAttribute, hasAttribute, hasAttributeOrFellow, hasBindingAnnotation, hasFellow, hasFellow, hasSubBindingAnnotation, initIndexCacheMap, insertBefore, invalidate, isChildable, isDisabledHostChanged, isInitialized, isInvalidated, isListenerAvailable, isVisible, onChildAdded, onChildRemoved, onPageAttached, onPageDetached, onParentChanged, onWrongValue, query, queryAll, redraw, redrawChildren, removeAttribute, removeAttribute, removeAttribute, removeCallback, removeChild, removeEventListener, removeForward, removeForward, removeRedrawCallback, removeScopeListener, removeShadowRoot, render, render, render, renderPropertiesOnly, replace, response, response, response, service, sessionDidActivate, sessionWillPassivate, setAttribute, setAttribute, setAttribute, setAuService, setAutag, setClientAttribute, setClientDataAttribute, setDefinition, setDefinition, setId, setMold, setPage, setPageBefore, setParent, setStubonly, setStubonly, setSubBindingAnnotationCount, setTemplate, setVisible, setVisibleDirectly, setWidgetClass, setWidgetListener, setWidgetOverride, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdateWidgetListener, smartUpdateWidgetOverride, toString, updateByClient, updateSubBindingAnnotationCount, willPassivate, willPassivate, willSerialize, willSerialize`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### Lineitem

          public Lineitem()

  - ### Method Detail

    - #### isPointVisible

          public boolean isPointVisible()

      Returns whether the point is visible.

      Default: true.

    - #### setPointVisible

          public void setPointVisible​(boolean pointVisible)

      Sets whether the point is visible.
      Parameters:
        `pointVisible` - whether the point is visible.

    - #### getPointStyle

          public java.lang.String getPointStyle()

      Returns the CSS style for the point.

    - #### setPointStyle

          public void setPointStyle​(java.lang.String pointStyle)

      Sets the pointStyle.
      Parameters:
        `pointStyle` - the CSS style for the point.

    - #### getPointImageSrc

          public java.lang.String getPointImageSrc()

      Returns the source URI of the point image.

      Default: null.

    - #### setPointImageSrc

          public void setPointImageSrc​(java.lang.String src)

      Sets the source URI of the point image.

      Calling this method implies setPointImageContent(null). In other words, the last invocation of `setPointImageSrc(java.lang.String)` overrides the previous `setPointImageContent(org.zkoss.image.Image)`, if any.

      Parameters:
        `src` - the URI of the image source
      See Also:
        `setPointImageContent(org.zkoss.image.Image)`, `setPointImageContent(RenderedImage)`

    - #### getPointImageContent

          public Image getPointImageContent()

      Returns the source content of the point image.

      Default: null.

      Since:
        10.0.0

    - #### setPointImageContent

          public void setPointImageContent​(Image image)

      Sets the pointImageContent directly.

      Default: null.

      Calling this method implies setPointImageSrc(null). In other words, the last invocation of `setPointImageContent(org.zkoss.image.Image)` overrides the previous `setPointImageSrc(java.lang.String)`, if any.

      Parameters:
        `image` - the image to display.
      See Also:
        `setPointImageSrc(java.lang.String)`

    - #### setPointImageContent

          public void setPointImageContent​(java.awt.image.RenderedImage image)

      Sets the pointImageContent directly with the rendered image. It actually encodes the rendered image to an PNG image (`Image`) with `Images.encode(java.lang.String, java.awt.image.RenderedImage, float, boolean)`, and then invoke `setPointImageContent(org.zkoss.image.Image)`.

    - #### getPointIconSclass

          public java.lang.String getPointIconSclass()

      Returns the iconSclass name of this point.

    - #### setPointIconSclass

          public void setPointIconSclass​(java.lang.String pointIconSclass)

      Sets the iconSclass name of the point.
      Parameters:
        `pointIconSclass` - the iconSclass name.

    - #### isOpposite

          public boolean isOpposite()

      Returns whether the first child is displayed in the first area(left/top).

      Default: false.

    - #### setOpposite

          public void setOpposite​(boolean opposite)

      Sets whether the first child is displayed in the first area(left/top).
      Parameters:
        `opposite` - whether the first child is displayed in the first area(left/top).

    - #### getFrontSpace

          public java.lang.String getFrontSpace()

      Returns the spacing with the previous lineitem.

    - #### setFrontSpace

          public void setFrontSpace​(java.lang.String frontSpace)

      Sets the spacing with the previous lineitem.
      Parameters:
        `frontSpace` - the spacing with the previous lineitem. (such as "5px" or "5em"). If null or empty (""), the default spacing is used (i.e., controlled by CSS alone).

    - #### getBackSpace

          public java.lang.String getBackSpace()

      Returns the spacing with the next lineitem.

    - #### setBackSpace

          public void setBackSpace​(java.lang.String backSpace)

      Sets the spacing with the next lineitem.
      Parameters:
        `backSpace` - the spacing with the next lineitem. (such as "5px" or "5em"). If null or empty (""), the default spacing is used (i.e., controlled by CSS alone).

    - #### beforeParentChanged

          public void beforeParentChanged​(Component parent)

      Description copied from class: `AbstractComponent`
      Default: If parent is null, execute the @Destroy method if any.
      Specified by:
        `beforeParentChanged` in interface `ComponentCtrl`
      Overrides:
        `beforeParentChanged` in class `AbstractComponent`
      Parameters:
        `parent` - the new parent. If null, it means detachment.
      See Also:
        `ComponentCtrl.beforeParentChanged(org.zkoss.zk.ui.Component)`

    - #### beforeChildAdded

          public void beforeChildAdded​(Component child,
                                       Component refChild)

      Description copied from class: `AbstractComponent`
      Default: does nothing.
      Specified by:
        `beforeChildAdded` in interface `ComponentCtrl`
      Overrides:
        `beforeChildAdded` in class `AbstractComponent`
      Parameters:
        `child` - the child to be added (never null).
        `refChild` - another child component that the new child will be inserted before it. If null, the new child will be the last child.
      See Also:
        `ComponentCtrl.beforeChildAdded(org.zkoss.zk.ui.Component, org.zkoss.zk.ui.Component)`

    - #### renderProperties

          protected void renderProperties​(ContentRenderer renderer)
                                   throws java.io.IOException

      Description copied from class: `HtmlBasedComponent`
      Renders the content of this component, excluding the enclosing tags and children.

      See also ZK Client-side Reference: Property Rendering

      Overrides:
        `renderProperties` in class `XulElement`
      Throws:
        `java.io.IOException`

    - #### getExtraCtrl

          public java.lang.Object getExtraCtrl()

      Description copied from class: `HtmlBasedComponent`
      Returns the client control for this component. It is used only by component developers.

      Default: creates an instance of `HtmlBasedComponent.ExtraCtrl`.

      Specified by:
        `getExtraCtrl` in interface `ComponentCtrl`
      Overrides:
        `getExtraCtrl` in class `HtmlBasedComponent`
      Returns:
        null if no special handling required. If the component requires some special controls, it could return an object that implements one or several interfaces in the org.zkoss.zk.ui.ext.render package. For example, `Cropper`.
      See Also:
        `ComponentCtrl.getExtraCtrl()`